[package]
name = "botx-api"
version = "0.1.7"
edition = "2021"
license = "MIT"
authors = ["Vidrochka"]
description = "Обертка над BotX api (eXpress)"
keywords = ["express", "botx", "botx-api", "lobss", "bot"]

[dependencies]
# use as http client
reqwest = { version="=0.11.17", features = ["json", "multipart"] }

serde = { version = "1.0", features = ["derive"] }
serde_json = "1.0"

tracing = "^0.1.37"

# auth logic
hmac = "0.12"
sha2 = "0.10"

thiserror = "1"

uuid = { version = "1.1", features = ["v4", "serde"] }

derive_builder = "0.12"

chrono = { version="0.4", features = ["serde"]}

easy-ext = "1"

anthill-di = { version = "1.2.4", optional = true }
async-trait-with-sync = { version = "0.1", optional = true }

async-lock = "2.6"

csv = "1.2"

[dev-dependencies]
anyhow = "1"
dotenv = "0.15"
env_logger = "0.10"
tokio = { version = "1.28", features = ["rt", "macros", "rt-multi-thread"] }

[features]
default = ["botx-api-v-all"]
botx-api-v-all = [
    "botx-api-v2",
    "botx-api-v3",
    "botx-api-v4",
]
botx-api-v2 = [
    "token",
    "smartapp-event",
]
botx-api-v3 = [
    "events-edit_event",
    "events-reply_event",
    "events-status",
    "events-typing",
    "events-stop_typing",
    "files-upload",
    "files-download",
    "stickers-new_sticker_pack",
    "stickers-sticker_packs_list",
    "stickers-add_sticker",
    "stickers-get_sticker_pack",
    "stickers-get_sticker",
    "stickers-update_sticker_pack",
    "stickers-delete_sticker",
    "stickers-delete_sticker_pack",
    "chats-list",
    "chats-info",
    "chats-add_user",
    "chats-remove_user",
    "chats-add_admin",
    "chats-set_stealth",
    "chats-disable_stealth",
    "chats-create",
    "chats-pin_message",
    "chats-unpin_message",
    "users-by_email",
    "users-by_huid",
    "users-by_login",
    "users-by_other_id",
    "users-users_as_csv",
]
botx-api-v4 = [
    "notifications-internal",
    "notifications-direct",
]
token = []
notifications-internal = []
notifications-direct = []
events-edit_event = []
events-reply_event = []
events-status = []
events-typing = []
events-stop_typing = []
files-upload = []
files-download = []
stickers-new_sticker_pack = []
stickers-sticker_packs_list = []
stickers-add_sticker = []
stickers-get_sticker_pack = []
stickers-get_sticker = []
stickers-update_sticker_pack = []
stickers-delete_sticker = []
stickers-delete_sticker_pack = []
chats-list = []
chats-info = []
chats-add_user = []
chats-remove_user = []
chats-add_admin = []
chats-set_stealth = []
chats-disable_stealth = []
chats-create = []
chats-pin_message = []
chats-unpin_message = []
users-by_email = []
users-by_huid = []
users-by_login = []
users-by_other_id = []
users-users_as_csv = []
smartapp-event = []
anthill-di = ["dep:anthill-di", "dep:async-trait-with-sync"]

[[example]]
name = "auth"